unit Question3_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Grids;

type
  TfrmQuestion3 = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    btnQuest31: TButton;
    btnQuest33: TButton;
    cmbPlaces: TComboBox;
    GroupBox2: TGroupBox;
    redOutput: TRichEdit;
    Label1: TLabel;
    stgMall: TStringGrid;
    procedure btnQuest31Click(Sender: TObject);
    procedure cmbPlacesChange(Sender: TObject);
    procedure btnQuest33Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion3: TfrmQuestion3;
  arrMall:array[1..5,1..7] of string =(('A','X','O','*','O','X','J'),('B','X','O','O','O','X','I'),('C','X','O','O','O','X','H'),('D','X','O','O','O','X','G'),('E','X','O','O','O','X','F'));
  arrPlace:array[1..10] of string;

implementation

{$R *.dfm}

procedure TfrmQuestion3.btnQuest31Click(Sender: TObject);
var
  iRow: Integer;
  iCol: Integer;
begin
for iRow := 1 to 5 do
   for iCol := 1 to 7 do
      stgMall.Cells[iCol,iRow]:= arrMall[iRow,iCol];
end;

procedure TfrmQuestion3.btnQuest33Click(Sender: TObject);
var
  iRow,a: Integer;
  iCol,iCounter: Integer;
  rDistance,rLowest: real;
  sPlace:string;
begin
redOutput.Clear;
  rLowest:=100;
  iCounter:=1;
  sPlace:='';
  for iRow := 1 to 5 do
   begin
    if arrMall[iRow,2] = '#' then
       begin
         rDistance:= 4.5*(iRow+1)+4.5;
         if rDistance <= rLowest then
            begin
             inc(iCounter);
             rLowest:=rDistance;
              arrPlace[iCounter]:=arrMall[iRow,1];
            end;
         redOutput.Lines.Add('Restaurant '+ arrMall[iRow,1]+' - approximately '+FloatToStrF(rDistance,ffFixed,4,1)+ ' metres');
       end;
       if arrMall[iRow,6] = '#' then
       begin
         rDistance:= 4.5*(iRow+1)+4.5;
         if rDistance <= rLowest then
            begin
             inc(iCounter);
             rLowest:=rDistance;
              arrPlace[iCounter]:=arrMall[iRow,7];
            end;
         redOutput.Lines.Add('Restaurant '+ arrMall[iRow,7]+' - approximately '+FloatToStrF(rDistance,ffFixed,4,1)+ ' metres');
       end;
   end;
     for a := 1 to iCounter do
       sPlace := sPlace + ' '  +arrPlace[a];

 redOutput.Lines.Add(' ');
 redOutput.Lines.Add('Your nearest friend(s) are at: '+ sPlace);
end;

procedure TfrmQuestion3.cmbPlacesChange(Sender: TObject);
var
  iRowChange:integer;
begin
  if cmbPlaces.Items[cmbPlaces.ItemIndex][1] in ['A'..'E'] then
    begin
     iRowChange:=cmbPlaces.ItemIndex +1;
     arrMall[iRowchange,2]:='#'
    end
  else
    begin
     iRowChange:=10-cmbPlaces.ItemIndex ;
     arrMall[iRowchange,6]:='#';
    end;
  btnQuest31.Click;
end;

end.
